unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Menus,
  ComCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ButtonSprung: TButton;
    ButtonBinaer: TButton;
    ButtonSequentiell: TButton;
    ButtonLoeschen: TButton;
    ButtonErzeugen: TButton;
    InputBuchstabe: TComboBox;
    InputAnzahl: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    OutputStelle: TLabel;
    Memo1: TMemo;
    OutputFortschritt: TProgressBar;
    procedure Button1Click(Sender: TObject);
    procedure ButtonBinaerClick(Sender: TObject);
    procedure ButtonErzeugenClick(Sender: TObject);
    procedure ButtonSprungClick(Sender: TObject);
    procedure ButtonLoeschenClick(Sender: TObject);
    procedure ButtonSequentiellClick(Sender: TObject);
    procedure Fehlercheck;
    function Binsuche(low, high: Integer): Integer;
    function Seqsuche(low, high: Integer; rate: Boolean): Integer;
    procedure Bubblesort;
  private

  public

  end;

var
  Form1: TForm1;
  Buchstaben: Array of Char;
  max, i: Integer;
  Suchstring: Char;
  gefunden: Boolean;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Fehlercheck;
begin
  if gefunden = false then
    OutputStelle.Caption := 'nicht gefunden';
end;

procedure Tausch(var a, b: Char);
var hilf: Char;
begin
   hilf := a;
   a := b;
   b := hilf;
end;

procedure TForm1.Bubblesort;
var
  sortiert: Boolean;
begin
  Memo1.Lines.Clear;

  repeat
    sortiert := true;
    for i := 0 to max-2 do begin
      OutputFortschritt.Position := Round(50*((i+1)/(max-1)));
      if Buchstaben[i] > Buchstaben[i+1] then begin
        tausch(Buchstaben[i], Buchstaben[i+1]);
          sortiert := false;
      end;
    end;
  until sortiert = true;

  for i := 0 to max-1 do
    Memo1.Lines.Add(Buchstaben[i]);
end;

function TForm1.Binsuche(low, high: Integer): Integer;
var
  Mitte: Integer;
begin
  // wenn Restarray leer
  if high - low = -1 then begin
    Result := -1;
    Exit;
  end
  else begin
    Mitte := low + (high-low) div 2;
    OutputFortschritt.Position := Round(50*((Mitte)/max)) + 50;

    if Suchstring = Buchstaben[Mitte] then begin
      Result := Mitte;
      gefunden := true;
    end
    else if Suchstring < Buchstaben[Mitte] then // Suche muss "links" der Mitte stehen
      Result := Binsuche(low, (Mitte - 1))
    else if Suchstring > Buchstaben[Mitte] then // Suche muss "rechts" der Mitte stehen
      Result := Binsuche((Mitte + 1), high)
  end;
end;

function TForm1.Seqsuche(low, high: Integer; rate: Boolean): Integer;
begin
  for i := low to high do begin
    if rate = true then
      OutputFortschritt.Position := Round(100*((i+1)/max));
    if Buchstaben[i] = Suchstring then begin
      Result := i;
      gefunden := true;
      Break;
    end;
  end;
end;

procedure TForm1.ButtonErzeugenClick(Sender: TObject);
var
  ZufBuchstabe: Char;
begin
  max := StrToInt(InputAnzahl.Text);
  OutputFortschritt.Position := 0;
  SetLength(Buchstaben, max);
  Randomize;

  for i := 0 to (max-1) do begin
    OutputFortschritt.Position := Round(100*((i+1)/max));
    ZufBuchstabe := chr(random(26)+97);
    Buchstaben[i] := ZufBuchstabe;
    Memo1.Lines.Add(ZufBuchstabe);
  end;
end;

procedure TForm1.ButtonSprungClick(Sender: TObject);
var
  abstand, j: Integer;
begin
  OutputFortschritt.Position := 0;
  gefunden := false;
  Suchstring := InputBuchstabe.Text[1];
  abstand := Round(sqrt(max - 1));

  Bubblesort;

  // in Abschnitten suchen
  for j := 1 to (max div abstand) do begin
    OutputFortschritt.Position := Round(50*(j/(max div abstand)) + 50);

    if Suchstring < Buchstaben[(j*abstand)] then begin
      OutputStelle.Caption := IntToStr(Seqsuche(((j-1)*abstand), ((j*abstand) - 1), false) + 1);
      Break;
    end;
  end;

  // "Rest" durchsuchen
  if gefunden = false then begin
    OutputStelle.Caption := IntToStr(Seqsuche((j*abstand), (max - 1), false) + 1);
  end;

  Fehlercheck;
end;

procedure TForm1.ButtonBinaerClick(Sender: TObject);
begin
  OutputFortschritt.Position := 0;
  gefunden := false;
  Suchstring := InputBuchstabe.Text[1];

  Bubblesort;

  OutputStelle.Caption := IntTostr(Binsuche(0, max-1) + 1);
  Fehlercheck;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Schluesselarray: Array [97..122] of Integer;
  Suchstring: String;
  Stelle: Integer;
begin
  OutputFortschritt.Position := 0;
  gefunden := false;
  Suchstring := InputBuchstabe.Text[1];

  // Schlüsselarray initialisieren
  for i := 97 to 122 do begin
    Schluesselarray[i] := -1;
    OutputFortschritt.Position := Round(50*((i-96)/26));
  end;

  // Zufallsbuchstaben zuordnen
  for i := 0 to (max-1) do begin
    Schluesselarray[ord(Buchstaben[i])] := i;
    OutputFortschritt.Position := Round(50*((i+1)/max)) + 50;
  end;

  // "Suchen"/Abfragen
  Stelle := Schluesselarray[ord(Suchstring[1])];

  if Stelle = -1 then
    Fehlercheck
  else
    OutputStelle.Caption := IntToStr(Stelle + 1);
end;

procedure TForm1.ButtonLoeschenClick(Sender: TObject);
begin
  Memo1.Lines.Clear;
  OutputFortschritt.Position := 0;
end;

procedure TForm1.ButtonSequentiellClick(Sender: TObject);
begin
  OutputFortschritt.Position := 0;
  gefunden := false;
  Suchstring := InputBuchstabe.Text[1];

  OutputStelle.Caption := IntToStr(Seqsuche(0, (max-1), true) + 1);
  Fehlercheck;
end;

end.

